<script setup lang="ts">
  import { TransitionRoot } from '@headlessui/vue';

  const { toasts, removeDuration, setDuration, closeToast } = useToasts();
</script>

<template>
  <Teleport to="body">
    <div
      v-if="toasts.length"
      name="toasts"
      class="z-toasts fixed right-10 top-10 flex flex-col gap-2"
    >
      <TransitionRoot
        v-for="item in toasts"
        :key="item.id"
        appear
        tag="div"
        :show="item.show"
        enter="transition ease-in-out duration-300 transform"
        enter-from="translate-x-full"
        enter-to="translate-x-0"
        leave="transition ease-in-out duration-300 transform"
        leave-from="translate-x-0"
        leave-to="translate-x-full"
      >
        <SwBanner
          type="toast"
          :variant="item.variant"
          @mouseenter="removeDuration(item.id)"
          @mouseleave="setDuration(item)"
          @close="closeToast(item.id)"
          @click="removeDuration(item.id)"
        >
          <span>
            {{ $t(item.content) }}
          </span>

          <template #action>
            <button
              v-if="item.actionText && item.actionFn"
              type="button"
              class="text-primary text-sm font-medium"
              @click="item.actionFn"
            >
              {{ $t(item.actionText) }}
            </button>
          </template>
        </SwBanner>
      </TransitionRoot>
    </div>
  </Teleport>
</template>
